;#<![CDATA[

;######################################################################################
;#  This file defines the following flash functions
;#  
;#  massEraseFlash - Entirely erases the device using whatever efficient means is available.
;#                   The device should be left in an unsecured state.
;#                   If such a function is not available TCL_ERROR should be returned 
;#                   and a slower page-by-page method will be used by the programmer.
;#
;#  isUnsecure - indicates if the device is secured in some fashion (read/write protected)
;#               Returns TCL_OK if NOT secured
;#
;#  initFlash - initialises the target for flash programing (if needed)
;#
;#  initTarget - initialises the target for general use
;#
;#  In addition the script may do any once-only initialisation such as setting global symbols
;#  when initially loaded into the TCL environment.
;#
proc loadSymbols {} {
   # Big-Endian format for writing numbers to memory
   setbytesex bigEndian

   set ::VBR_REG       0x801;
      
}
proc initTarget {}  {
}
proc initFlash { frequency } {
}
proc massEraseFlash {} {
;# ToDo
}
proc isUnsecure {} {
;# ToDo
}

loadSymbols
return

;#]]>
